unit Mainform;

interface

uses
	Kontakt,
  RakBinaryStreamData, miscfunc,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ActnList, ExtCtrls, Menus, ComCtrls, ExtDlgs, Clipbrd;

const
	UM_KONTAKT_DESELECTED = WM_USER + 1;
  UM_KONTAKT_SELECTED = WM_USER + 2;
  UM_SET_FOCUSED_CONTROL = WM_USER + 3;

type
  TFrmMain = class(TForm)
    Panel1: TPanel;
    PnlKontakt: TPanel;
    LsvKontakte: TListView;
    MainMenu1: TMainMenu;
    Datei2: TMenuItem;
    MnuClose: TMenuItem;
    N5: TMenuItem;
    Speichernunter2: TMenuItem;
    Speichern2: TMenuItem;
    ffnen2: TMenuItem;
    Neu2: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    EdtVorname: TEdit;
    EdtNachname: TEdit;
    EdtStrasse: TEdit;
    EdtPLZ: TEdit;
    EdtOrt: TEdit;
    EdtTelPrivat: TEdit;
    Label5: TLabel;
    EdtTelArbeit: TEdit;
    Label6: TLabel;
    EdtHandy: TEdit;
    Label7: TLabel;
    EdtEmail: TEdit;
    Label8: TLabel;
    Kontakt1: TMenuItem;
    Neu1: TMenuItem;
    Lschen1: TMenuItem;
    Panel3: TPanel;
    BtnNewKontakt: TButton;
    BtnDeleteKontakt: TButton;
    ActionList1: TActionList;
    ActKontaktNew: TAction;
    ActKontaktDelete: TAction;
    Kopieren2: TMenuItem;
    Einfgen2: TMenuItem;
    N1: TMenuItem;
    ActOpen: TAction;
    ActSave: TAction;
    ActSaveAs: TAction;
    ActNew: TAction;
    OdgKontakte: TOpenDialog;
    SdgKontakte: TSaveDialog;
    OpdBild: TOpenPictureDialog;
    ActKontaktCopy: TAction;
    ActKontaktInsert: TAction;
    Label9: TLabel;
    GroupBox1: TGroupBox;
    ImgBild: TImage;
    BtnLoadPicture: TButton;
    BtnDeletePicture: TButton;
    CckPrivat: TCheckBox;
    EdtGeburtstag: TEdit;
    procedure MnuCloseClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LsvKontakteSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ActOpenExecute(Sender: TObject);
    procedure ActNewExecute(Sender: TObject);
    procedure ActSaveExecute(Sender: TObject);
    procedure ActSaveAsExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure OnChanged(Sender: TObject);
    procedure BtnLoadPictureClick(Sender: TObject);
    procedure BtnDeletePictureClick(Sender: TObject);
    procedure ActKontaktNewExecute(Sender: TObject);
    procedure ActKontaktDeleteExecute(Sender: TObject);
    procedure OnKeyFieldExit(Sender: TObject);
    procedure ActKontaktCopyExecute(Sender: TObject);
    procedure ActKontaktInsertExecute(Sender: TObject);
  private
    { Private-Deklarationen }

    FHasChanged: boolean;
    FKontakte: TKontakte;
    FKontaktInitializing: boolean;
    FUpdatingList: boolean;
    FSelfSelecting: boolean;
    FIgnoreUM_KONTAKT_DESELECTED: boolean;
    FLastSelected: TKontakt;
    FDatei: string;

    procedure CheckEnabled;
    function InputToPuffer(Kontakt: TKontakt): boolean;

    procedure DateiLaden;
    function Speichern(ShowCancelButtton: boolean): integer;
    function SpeichernUnter(ShowCancelButtton: boolean): integer;
    function SpeichernAls(FileName: string): boolean;
    procedure Neu;

    procedure UpdateList(SelektKontakt: TKontakt);
    procedure UpdateKontakt;

    procedure UmKontaktDeselected(var Msg: TMessage); message UM_KONTAKT_DESELECTED;
    procedure UmKontaktSelected(var Msg: TMessage); message UM_KONTAKT_SELECTED;
    procedure UmSetFousedControl(var Msg: TMessage); message UM_SET_FOCUSED_CONTROL;

    procedure SetDatei(const Value: string);
    function GetSelectedKontakt: TKontakt;
		procedure SelectKontakt(Kontakt: TKontakt);
    procedure SetHasChanged(const Value: boolean);

    property HasChanged: boolean read FHasChanged write SetHasChanged;
    property Datei: string read FDatei write SetDatei;
    property SelectedKontakt: TKontakt read GetSelectedKontakt;
    procedure CalcImageSize;
  public
    { Public-Deklarationen }
  end;

var
  FrmMain: TFrmMain;

implementation

{$R *.DFM}

const
  APPNAME_CLIPBOARD = 'RakBinaryStreamDataTutorialKontakte';
  FULL_VERSION_NUMBER = 1;
  PART_VERSION_NUMBER = 1;
  BUGFIX_VERSION_NUMBER = 0;
var
	TClipboardFormat: word;


procedure TFrmMain.FormCreate(Sender: TObject);
begin
	FKontakte := TKontakte.Create;
  Neu;
end;

procedure TFrmMain.FormDestroy(Sender: TObject);
begin
  FKontakte.Free;
end;

procedure TFrmMain.MnuCloseClick(Sender: TObject);
begin
	Close();
end;

procedure TFrmMain.UpdateList(SelektKontakt: TKontakt);
var
  I: integer;
  Item: TListItem;
  SelItem: TListItem;
  Kontakt: TKontakt;
begin
	FUpdatingList := true;
  try
    SelItem := nil;
    if SelektKontakt = nil then
    begin // Wenn kein bestimmter selektiert werden soll
      // Dann soll am Schlu wieder der selbe selektiert sein
      SelektKontakt := SelectedKontakt;
    end;

    try
      LsvKontakte.Items.BeginUpdate;

      LsvKontakte.Items.Clear;
			FLastSelected := nil;

      for I := 0 to FKontakte.Count - 1 do
      begin
        Kontakt := FKontakte[I];

        Item := LsvKontakte.Items.Add;
        Item.Data := Kontakt;
        Item.Caption := Kontakt.Vorname;
        Item.SubItems.Add(Kontakt.Nachname);

        if Kontakt = SelektKontakt then
          SelItem := Item;
      end;
    finally
      LsvKontakte.Items.EndUpdate;
    end;
  finally
  	FUpdatingList := false;
  end;
  
  if (SelItem = nil) and (LsvKontakte.Items.Count > 0) then
    SelItem := LsvKontakte.Items[0];

  LsvKontakte.Selected := SelItem;
  if SelItem <> nil then
    SelItem.Focused := true;

  CheckEnabled;
end;

procedure TFrmMain.LsvKontakteSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
	if not FUpdatingList and not FSelfSelecting then
  begin
    if not Selected then
    begin
    	FIgnoreUM_KONTAKT_DESELECTED := false;
      FLastSelected := TKontakt(Item.Data);
      PostMessage(Handle, UM_KONTAKT_DESELECTED, 0, 0);
    end
    else
    begin
    	FIgnoreUM_KONTAKT_DESELECTED := true;
      PostMessage(Handle, UM_KONTAKT_SELECTED, 0, Longint(Item));
    end;
  end;
end;

procedure TFrmMain.UmKontaktDeselected(var Msg: TMessage);
var
  I: integer;
  SelItem: TListItem;
begin
	if not FIgnoreUM_KONTAKT_DESELECTED then
  begin
  	if (LsvKontakte.Selected = nil) and (LsvKontakte.Items.Count > 0) then
    begin
    	SelItem := LsvKontakte.Items[0];

      for I := 0 to LsvKontakte.Items.Count - 1 do
      begin
      	if LsvKontakte.Items[I].Data = FLastSelected then
        begin
        	SelItem := LsvKontakte.Items[I];
          break;
        end;
      end;

      LsvKontakte.Selected := SelItem;
      SelItem.Focused := true;
    end;
		CheckEnabled;
  end;
end;

procedure TFrmMain.UmKontaktSelected(var Msg: TMessage);
begin
	if FLastSelected <> SelectedKontakt then
  begin
    if InputToPuffer(FLastSelected) then
			UpdateKontakt;
  end;
  CheckEnabled;
end;

procedure TFrmMain.CalcImageSize;
var
  Width, Height: integer;
begin
  Width := ImgBild.Picture.Width;
  Height := ImgBild.Picture.Height;
  FitRect(Width, Height, 170, 190);
  ImgBild.Width := Width;
  ImgBild.Height := Height;
end;

procedure TFrmMain.UpdateKontakt;
var
  Kontakt: TKontakt;
begin
	Kontakt := SelectedKontakt;

  if Kontakt <> nil then
  begin
  	PnlKontakt.Visible := true;
  	FKontaktInitializing := true;
    try
      EdtVorname.Text := Kontakt.Vorname;
      EdtNachname.Text := Kontakt.Nachname;
      EdtStrasse.Text := Kontakt.Strasse;
      EdtPLZ.Text := Kontakt.GetPLZAsString;
      EdtOrt.Text := Kontakt.Ort;
      EdtTelPrivat.Text := Kontakt.TelPrivat;
      EdtTelArbeit.Text := Kontakt.TelArbeit;
      EdtHandy.Text := Kontakt.Handy;
      EdtEmail.Text := Kontakt.Email;
      EdtGeburtstag.Text := Kontakt.GetGeburtstagAsString;
      CckPrivat.Checked := Kontakt.Privat;

      ImgBild.Picture := Kontakt.Bild;
      CalcImageSize;
    finally
    	FKontaktInitializing := false;
    end;
  end;
  CheckEnabled;
end;

procedure TFrmMain.ActOpenExecute(Sender: TObject);
begin
	DateiLaden;
end;

procedure TFrmMain.DateiLaden;
var
  StreamData: TRakBinaryStreamData;
  Tag: TRakBinaryTag;
  R: integer;
  DoIt: boolean;
begin
  if OdgKontakte.Execute then
  begin
    DoIt := true;
    if HasChanged then
    begin
      R := Application.MessageBox('nderungen speichern?', 'Neue Kontakte laden', MB_YESNOCANCEL);
      if R = IDCANCEL  then
        DoIt := false
      else if R = IDYES then
        DoIt := Speichern(true) <> IDCANCEL;
    end;

    if DoIt then
    begin
      StreamData := TRakBinaryStreamData.Create;
      try
        if (StreamData.LoadFromFile(OdgKontakte.FileName) <> blrOK) 
          or (StreamData.ApplicationName <> 'RakBinaryStreamData Tutorial') then
        begin
          ShowMessage('Unbekanntes Datei-Format');
        end
        else
        begin
          Tag := StreamData.FindFirstTag('Kontakte');
          if Tag <> nil then
            FKontakte.LoadFromBinaryTag(Tag);

          Datei := OdgKontakte.FileName;
          HasChanged := false;
        end;
      finally
        StreamData.Free;
      end;

      UpdateList(nil);
    end;
  end;
end;

procedure TFrmMain.Neu;
var
  R: integer;
  DoIt: boolean;
begin
  DoIt := true;
  if HasChanged then
  begin
    R := Application.MessageBox('nderungen speichern?', 'Neue Kontakte-Datei anlegen',
      MB_YESNOCANCEL);
    if R = IDCANCEL  then
      DoIt := false
    else if R = IDYES then
      DoIt := Speichern(true) <> IDCANCEL;
  end;

  if DoIt then
  begin
    FKontakte.Clear;

    FLastSelected := nil;
    HasChanged := false;
    Datei := '';

    UpdateList(nil);
  end;
end;

procedure TFrmMain.SetDatei(const Value: string);
begin
  if FDatei <> Value then
  begin
    FDatei := Value;
    if FDatei = '' then
      Caption := 'Kontaktverwalter'
    else
      Caption := 'Kontaktverwalter - ' + FDatei;
  end;
end;

procedure TFrmMain.UmSetFousedControl(var Msg: TMessage);
begin
  try
    TWinControl(Msg.LParam).SetFocus;
  except;
  end;
end;

function TFrmMain.Speichern(ShowCancelButtton: boolean): integer;
begin
  if Datei = '' then
    Result := SpeichernUnter(ShowCancelButtton)
  else if SpeichernAls(Datei) then
    Result := IDYES
  else
    Result := IDCANCEL;
end;

function TFrmMain.SpeichernAls(FileName: string): boolean;
var
  SreamData: TRakBinaryStreamData;
begin
  Result := InputToPuffer(SelectedKontakt);
  if Result then
  begin
    try
      SreamData := TRakBinaryStreamData.Create;
      try
        SreamData.ApplicationName := 'RakBinaryStreamData Tutorial';
        SreamData.ApplicationVersion := '1.0.0';

        FKontakte.SaveToBinaryTag(SreamData.AddTag('Kontakte'));

        SreamData.SaveToFile(FileName);
      finally
        SreamData.Free;
      end;
      Datei := FileName;
      HasChanged := false;
    except
      Application.MessageBox('Die Datei konnte nicht gespeichert werden.'#13
        + 'Wahrscheinlich wollten sie auf einen nicht beschreibaren Datentrger schreiben (z.B. CD-ROM)'#13
        + 'oder der Datentrger ist voll.', PChar(FileName), MB_OK);
      Result := false;
    end;

    CheckEnabled;
  end;
end;

function TFrmMain.SpeichernUnter(ShowCancelButtton: boolean): integer;
var
  Buttons: integer;
begin
  Result := IDCANCEL;

  if InputToPuffer(SelectedKontakt) then
  begin
    if SdgKontakte.Execute then
    begin
      Result := IDYES;
      if FileExists(SdgKontakte.FileName) then
      begin
        if ShowCancelButtton then
          Buttons := MB_YESNOCANCEL
        else
          Buttons := MB_YESNO;

        Result := Application.MessageBox('Es existiert bereits eine gleichnamige Datei.'#13
          + 'Soll diese berschrieben werden?', PChar(SdgKontakte.FileName),
          Buttons);

        if (Result = IDYES) and ((FileGetAttr(SdgKontakte.FileName) and SysUtils.faReadOnly) > 0) then
        begin
          try
            FileSetAttr(SdgKontakte.FileName, FileGetAttr(SdgKontakte.FileName) and not SysUtils.faReadOnly);
          except
            Result := IDCANCEL;
            Application.MessageBox('Die Datei konnte nicht gespeichert werden.'#13
              + 'Wahrscheinlich wollten sie auf einen nicht beschreibaren Datentrger schreiben, z.B. CD-ROM.',
              PChar(SdgKontakte.FileName),
              MB_OK)
          end;
        end;
      end;

      if Result = IDYES then
      begin
        if not SpeichernAls(SdgKontakte.FileName) then
          Result := IDCANCEL;
      end;

      CheckEnabled;
    end;
  end;
end;

procedure TFrmMain.CheckEnabled;
var
  Kontakt: TKontakt;
begin
  Kontakt := SelectedKontakt;

  PnlKontakt.Visible := Kontakt <> nil;
  ActKontaktDelete.Enabled := Kontakt <> nil;
  ActKontaktCopy.Enabled := Kontakt <> nil;
  ActSave.Enabled := HasChanged;
end;

procedure TFrmMain.ActNewExecute(Sender: TObject);
begin
  Neu;
end;

procedure TFrmMain.ActSaveExecute(Sender: TObject);
begin
  Speichern(false);
end;

procedure TFrmMain.ActSaveAsExecute(Sender: TObject);
begin
  SpeichernUnter(false);
end;

procedure TFrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  R: integer;
begin
  if HasChanged then
  begin
    R := Application.MessageBox('nderungen speichern?', 'Programm schlieen',
      MB_YESNOCANCEL);
    if R = IDCANCEL  then
      CanClose := false
    else if R = IDYES then
      CanClose := Speichern(true) <> IDCANCEL;
  end;
end;

function TFrmMain.InputToPuffer(Kontakt: TKontakt): boolean;
begin
  Result := true;
  if (Kontakt <> nil) and (FKontakte.IndexOf(Kontakt) > -1) then
  begin
    Kontakt.Vorname := EdtVorname.Text;
    Kontakt.Nachname := EdtNachname.Text;
    Kontakt.Strasse := EdtStrasse.Text;
    Kontakt.Ort := EdtOrt.Text;
    Kontakt.TelPrivat := EdtTelPrivat.Text;
    Kontakt.TelArbeit := EdtTelArbeit.Text;
    Kontakt.Handy := EdtHandy.Text;
    Kontakt.Email := EdtEmail.Text;
    Kontakt.Privat := CckPrivat.Checked;
    Kontakt.Bild.Graphic := ImgBild.Picture.Graphic;

    Result := Kontakt.SetGeburtstagAsString(EdtGeburtstag.Text);
    if not Result then
    begin
      SelectKontakt(Kontakt);
      ShowMessage('Der Geburtstag muss in der Form Tag.Monat.Jahr eingegeben werden!');
      PostMessage(Handle, UM_SET_FOCUSED_CONTROL, 0, Longint(EdtGeburtstag));
    end
    else
    begin
      Result := Kontakt.SetPLZAsString(EdtPLZ.Text);
      if not Result then
      begin
        SelectKontakt(Kontakt);
        ShowMessage('Die Postleitzahl muss eine fnfstellige Zahl sein!');
        PostMessage(Handle, UM_SET_FOCUSED_CONTROL, 0, Longint(EdtPLZ));
      end;
    end;
  end;
end;

procedure TFrmMain.SelectKontakt(Kontakt: TKontakt);
var
  I: integer;
begin
  for I := 0 to LsvKontakte.Items.Count - 1 do
  begin
    if LsvKontakte.Items[i].Data = Kontakt then
    begin
      FSelfSelecting := true;
      try
        LsvKontakte.Selected := LsvKontakte.Items[i];
        LsvKontakte.Selected.Focused := true;
      finally
        FSelfSelecting := false;
      end;
      break;
    end;
  end;
end;

function TFrmMain.GetSelectedKontakt: TKontakt;
begin
  Result := nil;
  if (LsvKontakte.Selected <> nil) and (FKontakte.IndexOf(LsvKontakte.Selected.Data) > -1) then
    Result := TKontakt(LsvKontakte.Selected.Data);
end;

procedure TFrmMain.OnChanged(Sender: TObject);
begin
  if not FKontaktInitializing then
    HasChanged := true;
end;

procedure TFrmMain.BtnLoadPictureClick(Sender: TObject);
begin
  if OpdBild.Execute then
  begin
    ImgBild.Picture.LoadFromFile(OpdBild.FileName);
    CalcImageSize;
    HasChanged := true;
  end;
end;

procedure TFrmMain.BtnDeletePictureClick(Sender: TObject);
begin
  if ImgBild.Picture.Graphic <> nil then
  begin
    HasChanged := true;
    ImgBild.Picture.Graphic := nil;
  end;
end;

procedure TFrmMain.SetHasChanged(const Value: boolean);
begin
  if FHasChanged <> Value then
  begin
    FHasChanged := Value;
    CheckEnabled;
  end;
end;

procedure TFrmMain.ActKontaktNewExecute(Sender: TObject);
var
  Kontakt: TKontakt;
begin
  if InputToPuffer(SelectedKontakt) then
  begin
    Kontakt := FKontakte.NewKontakt;
    UpdateList(Kontakt);
    UpdateKontakt;
    HasChanged := true;
    EdtVorname.SetFocus;
  end;
end;

procedure TFrmMain.ActKontaktDeleteExecute(Sender: TObject);
begin
  if SelectedKontakt <> nil then
  begin
    FKontakte.Remove(SelectedKontakt);
    UpdateList(nil);
    HasChanged := true;
  end;
end;


procedure TFrmMain.OnKeyFieldExit(Sender: TObject);
begin
   LsvKontakte.Selected.Caption := EdtVorname.Text;
   LsvKontakte.Selected.SubItems[0] := EdtNachname.Text;
end;

procedure TFrmMain.ActKontaktCopyExecute(Sender: TObject);
var
  Data: TRakBinaryStreamData;
begin
  if InputToPuffer(SelectedKontakt) then
  begin // Wenn alle Eingaben an SelectedKontakt bergeben werden konnten
    // Den Container fr das Zwischenformat erzeugen
    Data := TRakBinaryStreamData.Create;
    try
      // Einen Namen festlegen, an dem wir erkennen knnen, mit welchen Daten wir es zu tun haben
      Data.ApplicationName := APPNAME_CLIPBOARD;

      // Die Daten des Kontaktes in das Zwischenformat kopieren
      SelectedKontakt.SaveToBinaryTag(Data);
      // Das Zwischenformat in die Zwischenablage bringen
      Data.SaveToClipboardFormat(TClipboardFormat);
    finally
      Data.Free;
    end;
  end;
end;

procedure TFrmMain.ActKontaktInsertExecute(Sender: TObject);
var
  Data: TRakBinaryStreamData;
  Kontakt: TKontakt;
begin
  Data := TRakBinaryStreamData.Create;
  try
    if Data.LoadFromClipboardFormat(TClipboardFormat) = blcrOK then
    begin
      if Data.ApplicationName = APPNAME_CLIPBOARD then
      begin // Wenn es wirklich die erwarteten Daten sind
        //Einen neuen Kontakt erzeugen
        Kontakt := FKontakte.NewKontakt;
        // Die Daten des Zwischenformats in den Kontakt bernehmen
        Kontakt.LoadFromBinaryTag(Data);
        // Dafr sorgen, dass alle Kontakte in der Liste angezeigt werden
        // und dass der neue Kontakt selektiert wird
        UpdateList(Kontakt);
      end;
    end;
  finally
    Data.Free;
  end;
end;

initialization
  TClipboardFormat := RegisterClipboardFormat(APPNAME_CLIPBOARD);

end.
